## org.apache.lucene.search
Class ConstantScoreQuery.ConstantScorer

    java.lang.Object
      org.apache.lucene.search.DocIdSetIterator
          org.apache.lucene.search.Scorer
              org.apache.lucene.search.ConstantScoreQuery.ConstantScorer

Enclosing class:
  ConstantScoreQuery

    protected class ConstantScoreQuery.ConstantScorer

extends Scorer

Field Summary

Fields inherited from class org.apache.lucene.search.DocIdSetIterator
`NO_MORE_DOCS`

Constructor Summary
`ConstantScoreQuery.ConstantScorer(Similarity similarity, IndexReader reader, Weight w)`

Method Summary
`int` `advance(int target)` Advances to the first beyond the current whose document number is greater than or equal to target.
`int` `doc()` Deprecated. use `docID()` instead.
`int` `docID()` Returns the following: -1 or `DocIdSetIterator.NO_MORE_DOCS` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
`Explanation` `explain(int doc)` Returns an explanation of the score for a document.
`boolean` `next()` Deprecated. use `nextDoc()` instead.
`int` `nextDoc()` Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set. NOTE: in 3.0 this method will become abstract, following the removal of `DocIdSetIterator.next()`.
`float` `score()` Returns the score of the current document matching the query.
`boolean` `skipTo(int target)` Deprecated. use `advance(int)` instead.

Methods inherited from class org.apache.lucene.search.Scorer
`getSimilarity, score, score, score, score`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ConstantScoreQuery.ConstantScorer

    public ConstantScoreQuery.ConstantScorer(Similarity similarity,
                                             IndexReader reader,
                                             Weight w)
                                      throws java.io.IOException

Throws:
  `java.io.IOException`

Method Detail

### next

    public boolean next()
                 throws java.io.IOException

  Deprecated. use `nextDoc()` instead.

  Description copied from class: `DocIdSetIterator`
  Unsupported anymore. Call `DocIdSetIterator.nextDoc()` instead. This method throws `UnsupportedOperationException` if called.

  Overrides:
    `next` in class `DocIdSetIterator`
  Throws:
    `java.io.IOException`

### nextDoc

    public int nextDoc()
                throws java.io.IOException

  Description copied from class: `DocIdSetIterator`
  Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
  NOTE: in 3.0 this method will become abstract, following the removal of `DocIdSetIterator.next()`. For backward compatibility it is implemented as:

       public int nextDoc() throws IOException {
         return next() ? doc() : NO_MORE_DOCS;
       }

  NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.

  Overrides:
    `nextDoc` in class `DocIdSetIterator`
  Throws:
    `java.io.IOException`

### doc

    public int doc()

  Deprecated. use `docID()` instead.

  Description copied from class: `DocIdSetIterator`
  Unsupported anymore. Call `DocIdSetIterator.docID()` instead. This method throws `UnsupportedOperationException` if called.

  Overrides:
    `doc` in class `DocIdSetIterator`

### docID

    public int docID()

  Description copied from class: `DocIdSetIterator`
  Returns the following:
  - -1 or `DocIdSetIterator.NO_MORE_DOCS` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
  - `DocIdSetIterator.NO_MORE_DOCS` if the iterator has exhausted.
  - Otherwise it should return the doc ID it is currently on.

  NOTE: in 3.0, this method will become abstract.

  Overrides:
    `docID` in class `DocIdSetIterator`

### score

    public float score()
                throws java.io.IOException

  Description copied from class: `Scorer`
  Returns the score of the current document matching the query. Initially invalid, until `DocIdSetIterator.next()` or `DocIdSetIterator.skipTo(int)` is called the first time, or when called from within `Collector.collect(int)`.

  Specified by:
    `score` in class `Scorer`
  Throws:
    `java.io.IOException`

### skipTo

    public boolean skipTo(int target)
                   throws java.io.IOException

  Deprecated. use `advance(int)` instead.

  Description copied from class: `DocIdSetIterator`
  Unsupported anymore. Call `DocIdSetIterator.advance(int)` instead. This method throws `UnsupportedOperationException` if called.

  Overrides:
    `skipTo` in class `DocIdSetIterator`
  Throws:
    `java.io.IOException`

### advance

    public int advance(int target)
                throws java.io.IOException

  Description copied from class: `DocIdSetIterator`
  Advances to the first beyond the current whose document number is greater than or equal to target. Returns the current document number or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.

  Behaves as if written:

       int advance(int target) {
         int doc;
         while ((doc = nextDoc()) < target) {
         }
         return doc;
       }

  Some implementations are considerably more efficient than that.

  NOTE: certain implementations may return a different value (each time) if called several times in a row with the same target.

  NOTE: this method may be called with 2147483647 for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

  NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.

  NOTE: in 3.0 this method will become abstract, following the removal of `DocIdSetIterator.skipTo(int)`.

  Overrides:
    `advance` in class `DocIdSetIterator`
  Throws:
    `java.io.IOException`

### explain

    public Explanation explain(int doc)
                        throws java.io.IOException

  Description copied from class: `Scorer`
  Returns an explanation of the score for a document.
  When this method is used, the `DocIdSetIterator.next()`, `DocIdSetIterator.skipTo(int)` and `Scorer.score(HitCollector)` methods should not be used.

  Overrides:
    `explain` in class `Scorer`
  Parameters:
    `doc` - The document number for the explanation.
  Throws:
    `java.io.IOException`

Copyright © 2000-2011 Apache Software Foundation. All Rights Reserved.